<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ErrorDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ErrorDetails
 * @subpackage Structs
 */
class ErrorDetails extends AbstractStructBase
{
    /**
     * The CorrectiveAction
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CorrectiveAction;
    /**
     * The ErrorDescription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorDescription;
    /**
     * The ErrorNo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorNo;
    /**
     * The ErrorSource
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorSource;
    /**
     * The FocusDataInstance
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FocusDataInstance;
    /**
     * The FocusDataItem
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FocusDataItem;
    /**
     * The FocusDataSegment
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FocusDataSegment;
    /**
     * The SeqNo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SeqNo;
    /**
     * The Severity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Severity;
    /**
     * Constructor method for ErrorDetails
     * @uses ErrorDetails::setCorrectiveAction()
     * @uses ErrorDetails::setErrorDescription()
     * @uses ErrorDetails::setErrorNo()
     * @uses ErrorDetails::setErrorSource()
     * @uses ErrorDetails::setFocusDataInstance()
     * @uses ErrorDetails::setFocusDataItem()
     * @uses ErrorDetails::setFocusDataSegment()
     * @uses ErrorDetails::setSeqNo()
     * @uses ErrorDetails::setSeverity()
     * @param string $correctiveAction
     * @param string $errorDescription
     * @param string $errorNo
     * @param string $errorSource
     * @param string $focusDataInstance
     * @param string $focusDataItem
     * @param string $focusDataSegment
     * @param string $seqNo
     * @param string $severity
     */
    public function __construct($correctiveAction = null, $errorDescription = null, $errorNo = null, $errorSource = null, $focusDataInstance = null, $focusDataItem = null, $focusDataSegment = null, $seqNo = null, $severity = null)
    {
        $this
            ->setCorrectiveAction($correctiveAction)
            ->setErrorDescription($errorDescription)
            ->setErrorNo($errorNo)
            ->setErrorSource($errorSource)
            ->setFocusDataInstance($focusDataInstance)
            ->setFocusDataItem($focusDataItem)
            ->setFocusDataSegment($focusDataSegment)
            ->setSeqNo($seqNo)
            ->setSeverity($severity);
    }
    /**
     * Get CorrectiveAction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCorrectiveAction()
    {
        return isset($this->CorrectiveAction) ? $this->CorrectiveAction : null;
    }
    /**
     * Set CorrectiveAction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $correctiveAction
     * @return \StructType\ErrorDetails
     */
    public function setCorrectiveAction($correctiveAction = null)
    {
        // validation for constraint: string
        if (!is_null($correctiveAction) && !is_string($correctiveAction)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($correctiveAction, true), gettype($correctiveAction)), __LINE__);
        }
        if (is_null($correctiveAction) || (is_array($correctiveAction) && empty($correctiveAction))) {
            unset($this->CorrectiveAction);
        } else {
            $this->CorrectiveAction = $correctiveAction;
        }
        return $this;
    }
    /**
     * Get ErrorDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorDescription()
    {
        return isset($this->ErrorDescription) ? $this->ErrorDescription : null;
    }
    /**
     * Set ErrorDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorDescription
     * @return \StructType\ErrorDetails
     */
    public function setErrorDescription($errorDescription = null)
    {
        // validation for constraint: string
        if (!is_null($errorDescription) && !is_string($errorDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorDescription, true), gettype($errorDescription)), __LINE__);
        }
        if (is_null($errorDescription) || (is_array($errorDescription) && empty($errorDescription))) {
            unset($this->ErrorDescription);
        } else {
            $this->ErrorDescription = $errorDescription;
        }
        return $this;
    }
    /**
     * Get ErrorNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorNo()
    {
        return isset($this->ErrorNo) ? $this->ErrorNo : null;
    }
    /**
     * Set ErrorNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorNo
     * @return \StructType\ErrorDetails
     */
    public function setErrorNo($errorNo = null)
    {
        // validation for constraint: string
        if (!is_null($errorNo) && !is_string($errorNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorNo, true), gettype($errorNo)), __LINE__);
        }
        if (is_null($errorNo) || (is_array($errorNo) && empty($errorNo))) {
            unset($this->ErrorNo);
        } else {
            $this->ErrorNo = $errorNo;
        }
        return $this;
    }
    /**
     * Get ErrorSource value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorSource()
    {
        return isset($this->ErrorSource) ? $this->ErrorSource : null;
    }
    /**
     * Set ErrorSource value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorSource
     * @return \StructType\ErrorDetails
     */
    public function setErrorSource($errorSource = null)
    {
        // validation for constraint: string
        if (!is_null($errorSource) && !is_string($errorSource)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorSource, true), gettype($errorSource)), __LINE__);
        }
        if (is_null($errorSource) || (is_array($errorSource) && empty($errorSource))) {
            unset($this->ErrorSource);
        } else {
            $this->ErrorSource = $errorSource;
        }
        return $this;
    }
    /**
     * Get FocusDataInstance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFocusDataInstance()
    {
        return isset($this->FocusDataInstance) ? $this->FocusDataInstance : null;
    }
    /**
     * Set FocusDataInstance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $focusDataInstance
     * @return \StructType\ErrorDetails
     */
    public function setFocusDataInstance($focusDataInstance = null)
    {
        // validation for constraint: string
        if (!is_null($focusDataInstance) && !is_string($focusDataInstance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($focusDataInstance, true), gettype($focusDataInstance)), __LINE__);
        }
        if (is_null($focusDataInstance) || (is_array($focusDataInstance) && empty($focusDataInstance))) {
            unset($this->FocusDataInstance);
        } else {
            $this->FocusDataInstance = $focusDataInstance;
        }
        return $this;
    }
    /**
     * Get FocusDataItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFocusDataItem()
    {
        return isset($this->FocusDataItem) ? $this->FocusDataItem : null;
    }
    /**
     * Set FocusDataItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $focusDataItem
     * @return \StructType\ErrorDetails
     */
    public function setFocusDataItem($focusDataItem = null)
    {
        // validation for constraint: string
        if (!is_null($focusDataItem) && !is_string($focusDataItem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($focusDataItem, true), gettype($focusDataItem)), __LINE__);
        }
        if (is_null($focusDataItem) || (is_array($focusDataItem) && empty($focusDataItem))) {
            unset($this->FocusDataItem);
        } else {
            $this->FocusDataItem = $focusDataItem;
        }
        return $this;
    }
    /**
     * Get FocusDataSegment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFocusDataSegment()
    {
        return isset($this->FocusDataSegment) ? $this->FocusDataSegment : null;
    }
    /**
     * Set FocusDataSegment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $focusDataSegment
     * @return \StructType\ErrorDetails
     */
    public function setFocusDataSegment($focusDataSegment = null)
    {
        // validation for constraint: string
        if (!is_null($focusDataSegment) && !is_string($focusDataSegment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($focusDataSegment, true), gettype($focusDataSegment)), __LINE__);
        }
        if (is_null($focusDataSegment) || (is_array($focusDataSegment) && empty($focusDataSegment))) {
            unset($this->FocusDataSegment);
        } else {
            $this->FocusDataSegment = $focusDataSegment;
        }
        return $this;
    }
    /**
     * Get SeqNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeqNo()
    {
        return isset($this->SeqNo) ? $this->SeqNo : null;
    }
    /**
     * Set SeqNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $seqNo
     * @return \StructType\ErrorDetails
     */
    public function setSeqNo($seqNo = null)
    {
        // validation for constraint: string
        if (!is_null($seqNo) && !is_string($seqNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seqNo, true), gettype($seqNo)), __LINE__);
        }
        if (is_null($seqNo) || (is_array($seqNo) && empty($seqNo))) {
            unset($this->SeqNo);
        } else {
            $this->SeqNo = $seqNo;
        }
        return $this;
    }
    /**
     * Get Severity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeverity()
    {
        return isset($this->Severity) ? $this->Severity : null;
    }
    /**
     * Set Severity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $severity
     * @return \StructType\ErrorDetails
     */
    public function setSeverity($severity = null)
    {
        // validation for constraint: string
        if (!is_null($severity) && !is_string($severity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($severity, true), gettype($severity)), __LINE__);
        }
        if (is_null($severity) || (is_array($severity) && empty($severity))) {
            unset($this->Severity);
        } else {
            $this->Severity = $severity;
        }
        return $this;
    }
}
